import { providers } from 'ethers';
import type { Peer } from '@cerc-io/peer';
import { Client } from '../client/client';
import { P2PMessageService } from '../client/engine/messageservice/p2p-message-service/service';
import { LedgerChannelInfo, PaymentChannelInfo } from '../client/query/types';
import { ChainService } from '../client/engine/chainservice/chainservice';
import { Voucher } from '../payments/vouchers';
export declare class Nitro {
    client: Client;
    msgService: P2PMessageService;
    chainService: ChainService;
    constructor(client: Client, msgService: P2PMessageService, chainService: ChainService);
    static setupClient(pk: string, chainURL: string, chainPk: string, contractAddresses: {
        [key: string]: string;
    }, peer: Peer, location?: string): Promise<Nitro>;
    static setupClientWithProvider(pk: string, provider: providers.JsonRpcProvider, contractAddresses: {
        [key: string]: string;
    }, peer: Peer, location?: string): Promise<Nitro>;
    private static getStore;
    static clearClientStorage(): Promise<boolean>;
    addPeerByMultiaddr(address: string, multiaddrString: string): Promise<void>;
    isPeerDialable(address: string): Promise<[boolean, string]>;
    directFund(counterParty: string, amount: number): Promise<string>;
    virtualFund(counterParty: string, amount: number): Promise<void>;
    pay(virtualPaymentChannel: string, amount: number): Promise<Voucher>;
    virtualDefund(virtualPaymentChannel: string): Promise<void>;
    directDefund(ledgerChannel: string): Promise<void>;
    getLedgerChannel(ledgerChannel: string): Promise<LedgerChannelInfo>;
    getAllLedgerChannels(): Promise<LedgerChannelInfo[]>;
    getPaymentChannel(paymentChannel: string): Promise<PaymentChannelInfo>;
    getPaymentChannelsByLedger(ledgerChannel: string): Promise<PaymentChannelInfo[]>;
}
